<?php
#error_reporting(E_ALL);
require_once 'Jabberd2.abstract.php';

class Ujabber extends Jabberd2
{
	public final function __construct($pConnectionType = 'write')
	{
		try
		{
			if ( !file_exists(dirname(__FILE__) . '/../instant_messenger.define.php') )
				throw new Exception(__CLASS__ . '[ ERROR #1 ] : Not found configuration file');

			require_once dirname(__FILE__) . '/../instant_messenger.define.php';

			if ( !(defined('IM_NAME_JABBER') && defined('IM_RESOURCE_JABBER')) )
				throw new Exception(__CLASS__ . '[ ERROR #2 ] : Jabber server is not cofigured');

			if ( !(defined('IM_SERVER_WEBJABBER') && defined('IM_PORT_JABBER')) )
				throw new Exception(__CLASS__ . '[ ERROR #3 ] : Webjabber server is not cofigured');

			$this->_server = constant('IM_NAME_JABBER');
			$this->_resource = constant('IM_RESOURCE_JABBER');

			$this->_port = constant('IM_PORT_JABBER');

			session_start();
			$this->_user = $_SESSION['phpgw_info']['instant_messenger']['user'];
			$this->_pass = $_SESSION['phpgw_info']['instant_messenger']['passwd'];
			session_write_close();

			$access_string = $this->_user . '@' . $this->_server . '/' . $this->_resource . ':' . $this->_port;

			$this->connected = false;
			if ( $this->connect($access_string, $this->_pass, $pConnectionType, constant('IM_SERVER_WEBJABBER')) )
				$this->connected = true;
		}
		catch(Exception $e)
		{
			echo $e->getMessage();
		}
	}

	public final function __destruct()
	{
		$this->closeSocket();
		ob_end_flush();
		flush();
	}

	public final function isConnected()
	{
		return $this->connected;
	}

	public final function listen()
	{
		if ( !$this->isConnected() )
			return "disconnected";

		if ( strpos($_SERVER['HTTP_USER_AGENT'], 'MSIE') )
		{
			sleep(1);
			$xml = $this->readSocket();
			printf("%s", $xml);
		}
		else
		{
			ob_end_clean();
			ignore_user_abort(true);
			ob_start();

			$init = time();
			$buffer = '';

			while ( ( connection_aborted() === 0 ) && time() - $init < 50 )
			{
				# read from server and write in the client
				$xml = $this->readSocket();
				//var_dump($xml);
				if ( strlen($xml) && $xml != ' ' )
				{
					if ( $xml[strlen($xml) - 1 ] != '>' )
					{
						$buffer .= $xml;
						$xml = '';
					}
					else
					{
						$xml = $buffer . $xml;
						$buffer = '';
						//var_dump($xml);
						//strlen($xml);
						//exit;
					}
				}
				$xml = ( strlen($xml) ) ? $xml : ' ';
				printf("%s", $xml);
				ob_flush();
				flush();
				usleep(6000);
			}
		}
	}

	public final function checkConnection()
	{
		$this->get_last_access_user();
		return $this->isConnected();
	}

	public final function Composing($pJid)
	{
		$pJid = $pJid['jid'];
		$id = 'chat' . "_" . time();
		$xml = "<message to='{$pJid}' type='chat' id='{$id}'><composing/></message>";
		$this->writeSocket($xml);
	}

	public final function Paused($pJid)
	{
		$pJid = $pJid['jid'];
		$id = 'chat' . "_" . time();
		$xml = "<message to='{$pJid}' type='chat' id='{$id}'><paused/></message>";
		$this->writeSocket($xml);
	}

	public final function SendMessage($pSendMessage)
	{
		if ( !$this->isConnected() )
			return "disconnected";

		$pSendMessage['body'] = stripslashes($pSendMessage['body']);

		$patterns = array('/&nbsp;| +/i', '/<br[^>]*>/i');
		$replace = array(' ', '<br />');
		$pSendMessage['body'] = preg_replace($patterns, $replace, $pSendMessage['body']);

		$_emotions  = '/<img emotion="(\S+)?"[^>]+>/';
		$_emotions = preg_match_all($_emotions, $pSendMessage['body'], $emotions);

		foreach ( $emotions[0] as $key => $val )
			$emotions[0][$key] = '/' . addcslashes($val, './()[]{}^$*&?') . '/i';

		$pSendMessage['body'] = preg_replace($emotions[0], $emotions[1], $pSendMessage['body']);

		$to = $pSendMessage['to'];
		$type = "chat";
		$id = "";
		$content = array(
			"subject" => $pSendMessage['subject'] ? $pSendMessage['subject'] : "",
			"thread"  => $pSendMessage['thread'] ? $pSendMessage['thread'] : "",
			"body"    => $pSendMessage['body'] ? $pSendMessage['body'] : ""
		);

		$payload = "";

		if ($to && is_array($content))
		{
			if (!$id)
			{
				$id = $type . "_" . time();
			}

			$xml = "<message to='$to' type='$type' id='$id'>";

			if ($content['subject'])
			{
				$xml .= "<subject>" . $content['subject'] . "</subject>";
			}

			if ($content['thread'])
			{
				$xml .= "<thread>" . $content['thread'] . "</thread>";
			}

			//Linha abaixo dentro do padro xmpp, entretanto clientes como
			//o PSI no seguem o padro assim ocorre problemas de comunicao
			//descomentar e retirar a seguinte para voltar ao padrão assim
			//que possvel
			//24/10/2007 - problema verificado por usurios do SERPRO na
			//plataforma Windows ocorrendo tambm no cliente Linux
			//por Alexandre e Rodrigo

			//$xml .= "<html><body>" . $content['body'] . "</body></html>";

			//retirar a linha abaixo para voltar ao padrão conforme acima
			$xml .= "<body><![CDATA[" . $content['body'] . "]]></body>";
			$xml .= $payload;
			$xml .= "</message>";
			unset($id);

			//echo $xml;
			$this->writeSocket($xml);
			$this->close();
		}
		else
		{
			//$this->writeLog("ERROR: SendMessage() #2");
			return false;
		}
	}
}
?>
